<?php
/**
 * Created by PhpStorm.
 * User: jderosa
 * Date: 21/02/20
 * Time: 10.56
 */

namespace FiloBlu\Rma\Plugin\Model;
use Magento\Sales\Model\Order;
use Magento\Rma\Api\RmaRepositoryInterface;
use Psr\Log\LoggerInterface;


class CancelChangeSizeOrderPlugin
{

    /**
     * @var Order 
     */
    protected $order;

    /**
     * @var RmaRepositoryInterface
     */
    protected $rmaRepository;

    /**
     * @var LoggerInterface
     */
    protected $logger;

    /**
     * CancelChangeSizeOrderPlugin constructor.
     * @param Order $order
     * @param RmaRepositoryInterface $rmaRepository
     * @param LoggerInterface $logger
     */
    public function __construct(
        Order $order,
        RmaRepositoryInterface $rmaRepository,
        LoggerInterface $logger){

        $this->order = $order;
        $this->rmaRepository = $rmaRepository;
        $this->logger = $logger;
    }

    /**
     * @param \Magento\Rma\Model\Rma $subject
     * @param $result
     * @return mixed
     */
    public function afterClose(\Magento\Rma\Model\Rma $subject, $result){
        try{
            $risultato = $result;
            $soggetto = $subject;
            if($result->getStatus() == 'closed'){
                $rma = $this->rmaRepository->get($subject->getEntityId());
                foreach ($rma->getItems() as $rmaItem){
                    $attributes = $rmaItem->getExtensionAttributes();
                    if($attributes === null){
                        continue;
                    }
                    $changeSizeOrderIncrementId = $rmaItem->getExtensionAttributes()->getOrderIncrementId();
                    $changeSizeOrder = $this->order->loadByIncrementId($changeSizeOrderIncrementId);
                    if($changeSizeOrder){
                        $changeSizeOrder->setStatus('canceled')->setState('canceled');
                        $changeSizeOrder->save();
                    }
                }

            }
            return $result;
        }catch (\Exception $e){
            $this->logger->critical($e->getMessage());
            return $result;
        }catch (\Throwable $t){
            $this->logger->critical($t->getMessage());
            return $result;
        }
    }
}